<template>
	<mobile-frame>
		<view class="main">
			<view class="one">
				<view class="one_1">
					<input type="text" v-model="searchInfo.customer_name" @input="toInput" placeholder="搜索购买者名称">
				</view>
				<view class="one_2">
					<button size="mini" @tap="toDislog">筛选</button>
				</view>
			</view>
			<view class="two">
				<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage" @scroll="toScroll">
					<view class="list-scroll-view">
						<view class="list" v-for="(item,index) in list" :key="index">
							<view class="list_1">
								<view class="list_1_1">
									<view class="shopname">
										<text class="iconfont icon-shangdian"></text>
										<text>{{item.shop.name}}</text>
									</view>
									<view class="status">
										{{item.zhStatus||'暂无'}}
									</view>
								</view>
								<view class="list_1_2">
									<view class="goods">
										<view class="goods_1">
											<image class="image" v-if="item.spec.file&&item.spec.file.length>0"
												:src="item.spec.file&&item.spec.file.length>0?item.spec.file[0].url:''"
												mode=""></image>
											<image class="image" v-else
												:src="item.goods.file&&item.goods.file.length>0?item.goods.file[0].url:''"
												mode=""></image>
										</view>
										<view class="goods_2">
											<view class="goodsname textOver">
												{{item.goods.name}}
											</view>
											<view class="specs">
												{{item.spec.name}}
											</view>
											<view class="time">
												购买者：{{item.customer.name}}
											</view>
											<view class="time">
												购买时间：{{item.buy_time}}
											</view>
										</view>
										<view class="goods_3">
											<view class="price">
												¥{{item.spec.price||0}}
											</view>
											<view class="num">
												×{{item.num||0}}
											</view>
										</view>
									</view>
								</view>
								<view class="other">
									<text>共{{item.num||0}}件商品</text>
									<text>实付款¥{{item.pay}}</text>
								</view>
							</view>
							<view class="btn">
								<button type="default" size="mini" @tap.stop="toView(item,'order')">详细信息</button>
								<button v-if="item.status=='2'||item.status=='3'||item.status=='2-'" size="mini"
									@tap.stop="toLogi(item)">查看物流</button>
								<button v-if="item.is_afterSale==true" size="mini" @tap.stop="toHandle(item)">售后处理</button>
							</view>
						</view>
						<view class="is_bottom" v-if="is_bottom">
							<text>{{config.bottom_title}}</text>
						</view>
					</view>
				</scroll-view>
			</view>
			<view class="dialog" v-if="dialog.show==true">
				<view class="dialog_1" v-if="dialog.type=='1'">
					<uni-forms ref="form" :modelValue="searchInfo" :rules="rules" label-width="auto">
						<uni-forms-item label="状态" name="status">
							<picker class="picker" mode="selector" :range="statusList" @change="statusChange"
								range-key="label">
								<view>{{status_name||'请选择状态'}}</view>
							</picker>
						</uni-forms-item>
					</uni-forms>
					<view class="btn">
						<button type="primary" @click="onSubmit" size="mini">确定</button>
						<button type="primary" @click="dialogClose" size="mini">取消</button>
					</view>
				</view>
				<view class="dialog_1" v-else-if="dialog.type=='2'">
					<uni-forms ref="form" :modelValue="afterInfo" :rules="rules" label-width="auto">
						<uni-forms-item label="售后类型" name="zhType">
							<uni-easyinput disabled  type="text" v-model="afterInfo.zhType" placeholder="请输入售后类型" />
						</uni-forms-item>
						<uni-forms-item label="售后状态" name="zhStatus">
							<uni-easyinput disabled  type="text" v-model="afterInfo.zhStatus" placeholder="请输入售后状态" />
						</uni-forms-item>
						<uni-forms-item label="申请理由" name="zhReason">
							<uni-easyinput disabled  type="text" v-model="afterInfo.zhReason" placeholder="请输入申请理由" />
						</uni-forms-item>
						<uni-forms-item label="退款金额" name="money">
							<uni-easyinput disabled  type="text" v-model="afterInfo.money" placeholder="请输入退款金额" />
						</uni-forms-item>
						<uni-forms-item label="售后申请时间" name="apply_time">
							<uni-easyinput disabled  type="text" v-model="afterInfo.apply_time" placeholder="请输入售后申请时间" />
						</uni-forms-item>
						<uni-forms-item label="申请售后描述" name="desc">
							<uni-easyinput disabled  type="textarea" v-model="afterInfo.desc" placeholder="请输入申请售后描述" />
						</uni-forms-item>
					</uni-forms>
					<view class="btn">
						<button type="primary" @click="toAgree(true)" size="mini">同意</button>
						<button type="primary" @click="toAgree(false)" size="mini">不同意</button>
					</view>
				</view>
			</view>
		</view>
	</mobile-frame>
</template>

<script>
	export default {
		data() {
			return {
				// 系统设置
				config: {},
				// 设备信息
				system: {},
				user: {},
				id: '',
				searchInfo: {},
				list: [],
				afterInfo:{},
				total: 0,
				skip: 0,
				limit: 6,
				page: 0,
				// 数据是否触底
				is_bottom: false,
				scrollTop: 0,
				// 字典表
				statusList: [],
				// 售后类型
				typeList:[],
				// 售后状态
				astatusList:[],
				// 理由
				reasonList:[],
				status_name: "",
				// 条件弹出框
				dialog: {
					show: false,
					type: '1'
				}
			};
		},
		onLoad: function(e) {
			const that = this;
			that.$set(that, `id`, e.id || '');
			that.searchConfig();
		},
		onShow: async function(e) {
			const that = this;
			await that.searchOther();
			await that.watchlogin();
		},
		onPullDownRefresh: async function() {
			const that = this;
			that.clearPage();
			await that.search();
			uni.stopPullDownRefresh();
		},
		methods: {
			// 查询基本设置
			searchConfig() {
				const that = this;
				uni.getStorage({
					key: 'config',
					success: function(res) {
						if (res.data) that.$set(that, `config`, res.data)
						// 设备平台信息
						let config = that.$config;
						that.$set(that, `system`, config.system);
					},
					fail: function(err) {
						console.log(err);
					}
				})
			},
			// 监听用户是否登录
			watchlogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: function(res) {
						let user = that.$jwt(res.data);
						if (user) {
							that.$set(that, `user`, user)
							that.search();
						}
					}
				})
			},
			async search() {
				const that = this;
				let info = {
					skip: that.skip,
					limit: that.limit,
					group: that.id
				}
				let res = await that.$api(`/groupOrder/userView`, 'GET', {
					...info,
					...that.searchInfo
				}, 'group');
				if (res.errcode == '0') {
					let list = [...that.list, ...res.data];
					for (let val of list) {
						if (val.status) val.zhStatus = that.searchStatus(val.status)
					}
					that.$set(that, `list`, list);
					that.$set(that, `total`, res.total)
				} else {
					uni.showToast({
						title: res.errmsg,
						icon: 'none'
					})
				}
			},
			// 查询状态
			searchStatus(e) {
				const that = this;
				let data = that.statusList.find((i) => i.value == e);
				if (data) return data.label
				else return '暂无'
			},
			// 订单详细信息
			toView(item) {
				const that = this;
				that.clearPage();
				uni.navigateTo({
					url: `/pagesMy/dough/info?id=${item._id}`
				})
			},
			// 分页
			toPage(e) {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();
				} else that.$set(that, `is_bottom`, true)
			},
			toScroll(e) {
				const that = this;
				let up = that.scrollTop;
				that.$set(that, `scrollTop`, e.detail.scrollTop);
				let num = Math.sign(up - e.detail.scrollTop);
				if (num == 1) that.$set(that, `is_bottom`, false);
			},
			// 查询条件
			toDislog() {
				const that = this;
				that.$set(that, `searchInfo`, {})
				that.$set(that, `status_name`, '')
				that.$set(that, `dialog`, {
					show: true,
					type: '1'
				})
			},
			// 售后处理
			async toHandle(e){
				const that = this; 
				let res = await that.$api(`/groupAfterSale`, 'GET', {
					order:e._id,
					customer:e.customer._id
				}, 'group')
				if (res.errcode == '0') {
					for (let val of res.data) {
						let type = that.typeList.find(i => i.value == val.type)
						if (type) val.zhType = type.label;
						let status = that.astatusList.find(i => i.value == val.status)
						if (status) val.zhStatus = status.label;
						let reason = that.reasonList.find(i => i.value == val.reason)
						if (reason) val.zhReason = reason.label;
					}
					that.$set(that, `afterInfo`, res.data[0]);
				}
				that.$set(that, `dialog`, {
					show: true,
					type: '2'
				})
			},
			// 售后同意
			async toAgree(e){
				const that = this;
				uni.showModal({
					title: '提示',
					content: '确定处理该订单吗?',
					success: async function(res) {
						if (res.confirm) {
							let arr = await that.$api(`/groupAfterSale/${that.afterInfo._id}`, 'POST', {
								leader_suggest: e
							}, 'group')
							if (arr.errcode == '0') {
								uni.showToast({
									title: '处理完成',
									icon: 'none'
								})
								that.$set(that, `dialog`, {
									show: false,
									type: '2'
								})
								that.$set(that, `afterInfo`, {})
								that.clearPage();
								that.search();
							} else {
								uni.showToast({
									title: arr.errmsg,
									icon: 'none'
								})
								that.$set(that, `dialog`, {
									show: false,
									type: '2'
								})
								that.$set(that, `afterInfo`, {})
								that.clearPage();
								that.search();
							}
						}
					}
				});
			},
			// 状态选择
			statusChange(e) {
				const that = this;
				let data = that.statusList[e.detail.value];
				if (data) {
					that.$set(that.searchInfo, `status`, data.value);
					that.$set(that, `status_name`, data.label);
				}
			},
			// 关闭弹框
			dialogClose() {
				const that = this;
				that.clearPage();
				that.search();
				that.$set(that, `dialog`, {
					show: false,
					type: '1'
				})
			},
			// 查询
			onSubmit() {
				const that = this;
				that.clearPage();
				that.search();
				that.$set(that, `dialog`, {
					show: false,
					type: '1'
				})
			},
			// 查看物流
			toLogi(e) {
				const that = this;
				that.clearPage();
				uni.navigateTo({
					url: `/pagesMy/logistics/index?id=${e._id}&type=${'groupOrder'}`
				})
			},
			// 查询其他信息
			async searchOther() {
				const that = this;
				let res;
				// 查询状态
				res = await that.$api(`/dictData`, 'GET', {
					code: 'order_process'
				})
				if (res.errcode == '0') that.$set(that, `statusList`, res.data);
				res = await that.$api(`/dictData`, 'GET', {
					code: "afterSale_type"
				});
				if (res.errcode == '0') that.$set(that, `typeList`, res.data)
				res = await that.$api(`/dictData`, 'GET', {
					code: "afterSale_status"
				});
				if (res.errcode == '0') that.$set(that, `astatusList`, res.data)
				res = await that.$api(`/dictData`, 'GET', {
					code: "afterSale_reason"
				});
				if (res.errcode == '0') that.$set(that, `reasonList`, res.data)
			},
			// 输入框
			toInput(e) {
				const that = this;
				if (that.searchInfo.customer_name) that.$set(that.searchInfo, `customer_name`, e.detail.value)
				else that.$set(that, `searchInfo`, {})
				that.clearPage();
				that.search();
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 6)
				that.$set(that, `page`, 0)
			}
		},

	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			display: flex;
			justify-content: center;
			align-items: center;
			padding: 2vw;
			
			.one_1 {
				padding: 0 2vw;
				width: 75vw;
			
				input {
					padding: 2vw;
					background-color: var(--f1Color);
					font-size: var(--font14Size);
					border-radius: 5px;
				}
			}
			button {
				background-color: #23B67A;
				color: #ffffff;
			}
		}

		.two {
			position: relative;
			flex-grow: 1;
			background-color: var(--f9Color);

			.list {
				background-color: #fff;
				border: 1px solid var(--f5Color);
				padding: 2vw;
				margin: 0 2vw 2vw 2vw;
				border-radius: 5px;

				.list_1 {
					.list_1_1 {
						display: flex;
						justify-content: space-between;
						margin: 0 0 2vw 0;

						.shopname {
							text:last-child {
								padding: 0 0 0 2vw;
							}
						}

						.status {
							color: var(--fFB1Color);
						}
					}

					.list_1_2 {
						border-bottom: 1px solid #f1f1f1;

						.goods {
							display: flex;
							padding: 0 0 2vw 0;

							.goods_1 {
								width: 20vw;
								height: 20vw;

								.image {
									width: 100%;
									height: 100%;
									border-radius: 5px;
								}
							}

							.goods_2 {
								width: 55vw;
								padding: 0 0 0 2vw;

								.goodsname {
									font-size: 16px;
									margin: 0 0 1vw 0;
								}

								.specs {
									font-size: 14px;
									color: #858585;
								}

								.time {
									font-size: 13px;
									color: #858585;
								}
							}

							.goods_3 {
								width: 15vw;
								text-align: right;

								.price {
									color: var(--fFB1Color);
								}
							}
						}
					}

					.other {
						padding: 0 0 2vw 0;
						margin: 2vw 0;
						text-align: right;
						border-bottom: 1px solid #f1f1f1;

						text {
							font-size: 14px;
							padding: 0 0 0 2vw;
						}
					}
				}

				.btn {
					text-align: right;

					button {
						margin: 0 1vw 0 0;
					}
				}
			}
		}
	}

	.dialog {
		position: fixed;
		width: 96vw;
		height: 100vh;
		background-color: #ffffff;
		z-index: 99999;
		display: flex;
		flex-direction: column;
		padding: 2vw;

		.uni-input {
			border: #f1f1ff 1px solid;
			padding: 2vw 2vw;
			border-radius: 1vw;
		}

		.picker {
			border: 1px solid #3333;
			border-radius: 5px;
			padding: 2vw;
		}

		.btn {
			text-align: center;

			button {
				margin: 0 2vw 2vw 2vw;
				background-color: #23B67A;
				color: #ffffff;
			}

			.name {
				color: var(--f85Color);
				font-size: var(--font14Size);
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: #858585;
			font-size: 14px;
		}
	}
</style>
